/*
UNIVERSITY OF UTAH RESEARCH FOUNDATION PUBLIC LICENSE
	
1. Definitions

1.1 "Commercial Use" means covered code utilized by USER to generate a
  revenue stream, including but not limited to, embedding the source
  code in USER's proprietary software, executable software, or
  consulting utilizing the source code.

1.2 "Contributor" means each entity that creates or contributes to the
  creation of Modifications.

1.3 "Covered Code" means the Original Source Code, Modifications, or
  the combination of the Original Source Code and Modifications, in
  each case including portions thereof. The Original Source Code,
  developed by the University of Utah, hereinafter referred to as
  UNIVERSITY is described in the Source Code notice required by
  Exhibit A.

1.4 "Source Code" means the preferred form of the Covered Code for
  making modifications to it, including all modules it contains, plus
  any associated interface definition files, scripts used to control
  compilation and installation of an Executable, or a list of source
  code differential comparisons against either the Original Source
  Code or another well known, available Covered Code of the
  Contributor's choice. The Source Code can be in a compressed or
  archival form, provided the appropriate decompression or
  de-archiving software is widely available for no charge.

1.5 "Electronic Distribution Mechanism" means a mechanism generally
  accepted in the software development community for the electronic
  transfer of data.

1.6 "Larger Work" means a work, which combines Covered Code or
  portions thereof with code not governed by the terms of this
  License.

1.7 "License" means this document.

1.8 "Licensable" means having the right to grant, to the maximum
  extent possible, whether at the time of the initial grant or
  subsequently acquired, any and all rights conveyed herein.

1.9 "Modifications" means any addition to or deletion from the
  substance or structure of either the Original Source Code or any
  previous Modifications. When Covered Code is released as a series of
  files, a Modification is:

  (a) Any addition to or deletion from the contents of a file
      containing Original Code or previous Modifications.

  (b) Any new file that contains any part of the Original Code or
      previous Modifications

1.10 "USER" (or "YOU") means an individual or a legal entity
  exercising rights under, and complying with all of the terms of this
  License. For legal entities, USER includes any entity, which
  controls, is controlled by, or is under common control with You. For
  purposes of this definition, "control" means (a) the power, direct
  or indirect, to cause the direction or management of such entity,
  whether by contract or otherwise, or (b) ownership of fifty percent
  (50%) or more of the outstanding shares or beneficial ownership of
  such entity.

2. Source Code License.

2.1 The Initial Developer Grant The UNIVERSITY hereby grants USER a
  world-wide, royalty-free, non-exclusive license, subject to third
  party intellectual property claims:

  (a) to use, reproduce, modify, display, and perform, the Covered
  Code (or portions thereof) with or without Modifications, or as part
  of a Larger Work.; and

  (b) under patents now or hereafter owned or controlled by
  UNIVERSITY, to make, have made, and use ("Utilize") the Covered
  Code(or portions thereof), but solely to the extent that any such
  patent is reasonably necessary to enable USER to Utilize the Covered
  Code (or portions thereof) and not to any greater extent that may be
  necessary to Utilize further Modifications or combinations.

  (c) the licenses granted in this Section 2.1(a) and (b) are
  effective on the date the USER first receives Covered Code.

  (d) No License is granted by UNIVERSITY for the Commercial Use of
  Covered Code under this License.

  (e) No License is granted by UNIVERSITY for the distribution of
  Covered Code under this License.


2.2. Contributor Grant. Each Contributor hereby grants UNIVERSITY a
  world-wide, royalty-free, non-exclusive license, subject to third
  party intellectual property claims:

  (a) to use, reproduce, modify, display, perform, sublicense and
  distribute the Modifications created by such Contributor (or
  portions thereof) either on an unmodified basis, with other
  Modifications, as Covered Code or as part of a Larger Work; and

  (b) under patents now or hereafter owned or controlled by
  Contributor, to Utilize the Covered Code (or portions thereof), but
  solely to the extent that any such patent is reasonably necessary to
  enable USER to Utilize the Contributor Version (or portions
  thereof), and not to any greater extent that may be necessary to
  Utilize further Modifications or combinations.

  (c) the licenses granted in this Section 2.2(a) and (b) are
  effective on the date the UNIVERSITY first receives the Covered Code

3. Contributor Obligations

3.1. Intellectual Property Matters

  (a) Third Party Claims. If USER has knowledge that a party claims an
  intellectual property right in particular functionality or code (or
  its utilization under this License), USER must include a text file
  with the source code provided to UNIVERSITY titled "LEGAL" which
  describes the claim and the party making the claim in sufficient
  detail that UNIVERSITY will know whom to contact. If USER obtains
  such knowledge after USER makes the Modification available to
  UNIVERSITY, USER shall promptly modify the LEGAL file in all copies
  USER makes available thereafter and shall notify UNIVERSITY that new
  knowledge has been obtained.

  (b) Contributor APIs. If Your Modification is an application
  programming interface and USER owns or controls patents, which are
  reasonably necessary to implement that API, you must also include
  this information in the LEGAL file.

3.2. Required Notices. USER must duplicate the notice in Exhibit A in
  each file of the Source Code, and this License in any documentation
  for the Source Code, where USER describes recipients' rights
  relating to Covered Code. If USER created one or more
  Modification(s), USER may add name as a Contributor to the notice
  described in Exhibit A. If it is not possible to put such notice in
  a particular Source Code file due to its structure, then USER must
  include such notice in a location (such as a relevant directory
  file) where a user would be likely to look for such a notice.

3.3. Distribution of Executable Versions. - This license does not
  allow distribution of the Covered Code by USER or Contributor.

3.4. Larger Works. USER may create a Larger Work by combining Covered
  Code with other code not governed by the terms of this License. In
  such a case, USER must make sure the requirements of this License
  are fulfilled for the Covered Code including 2.1d and 2.1e.

4. Inability to Comply Due to Statute or Regulation.

  If it is impossible for USER to comply with any of the terms of this
  License with respect to some or all of the Covered Code due to
  statute or regulation then USER must:

  (a) comply with the terms of this License to the maximum extent
  possible; and

  (b) describe the limitations and the code they affect. Such
  description must be included in the LEGAL file described in Section
  3.1 and must be included with all distributions of the Source
  Code. Except to the extent prohibited by statute or regulation, such
  description must be sufficiently detailed for a recipient of
  ordinary skill to be able to understand it.

5. Application of this License.

  This License applies to Covered Code attached to the notice in Exhibit A.

6. DISCLAIMER OF WARRANTY.

  COVERED CODE IS PROVIDED UNDER THIS LICENSE ON AN "AS IS" BASIS,
  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
  INCLUDING, WITHOUT LIMITATION, WARRANTIES THAT THE COVERED CODE IS
  FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE OR
  NON-INFRINGING. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF
  THE COVERED CODE IS WITH USER. SHOULD ANY COVERED CODE PROVE
  DEFECTIVE IN ANY RESPECT, YOU (NOT THE UNIVERSITY OR ANY OTHER
  CONTRIBUTOR) ASSUME THE COST OF ANY NECESSARY SERVICING, REPAIR OR
  CORRECTION. THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL
  PART OF THIS LICENSE. NO USE OF ANY COVERED CODE IS AUTHORIZED
  HEREUNDER EXCEPT UNDER THIS DISCLAIMER.

7. TERMINATION.

  This License and the rights granted hereunder will terminate
  automatically if USER fails to comply with terms herein. All
  sublicenses to the Covered Code which are properly granted shall
  survive any termination of this License. Provisions which, by their
  nature, must remain in effect beyond the termination of this License
  shall survive.

8. LIMITATION OF LIABILITY.

  UNDER NO CIRCUMSTANCES AND UNDER NO LEGAL THEORY, WHETHER TORT
  (INCLUDING NEGLIGENCE), CONTRACT, OR OTHERWISE, SHALL THE
  UNIVERSITY, ANY OTHER CONTRIBUTOR, OR ANY DISTRIBUTOR OF COVERED
  CODE, OR ANY SUPPLIER OF ANY OF SUCH PARTIES, BE LIABLE TO USER OR
  ANY OTHER PERSON FOR ANY INDIRECT, SPECIAL, INCIDENTAL, OR
  CONSEQUENTIAL DAMAGES OF ANY CHARACTER INCLUDING, WITHOUT
  LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK STOPPAGE, COMPUTER
  FAILURE OR MALFUNCTION, OR ANY AND ALL OTHER COMMERCIAL DAMAGES OR
  LOSSES, EVEN IF SUCH PARTY SHALL HAVE BEEN INFORMED OF THE
  POSSIBILITY OF SUCH DAMAGES. THIS LIMITATION OF LIABILITY SHALL NOT
  APPLY TO LIABILITY FOR DEATH OR PERSONAL INJURY RESULTING FROM SUCH
  PARTY'S NEGLIGENCE TO THE EXTENT APPLICABLE LAW PROHIBITS SUCH
  LIMITATION. SOME JURISDICTIONS DO NOT ALLOW THE EXCLUSION OR
  LIMITATION OF INCIDENTAL OR CONSEQUENTIAL DAMAGES, SO THAT EXCLUSION
  AND LIMITATION MAY NOT APPLY TO USER.


9. U.S. GOVERNMENT END USERS,

  The Covered Code is a "commercial item," as that term is defined in
  48 C.F.R. 2.101 (Oct. 1995). consisting of "commercial computer
  software" and "commercial computer software documentation," as such
  terms are used in 48 C.F.R. 12.212 (Sept. 1995). Consistent with 48
  C.F.R. 12.212 and 48 C.F.R. 227.7202-1 through 227.7202-4 (June
  1995), all U.S. Government End Users acquire Covered Code with only
  those rights set forth herein.

10. MISCELLANEOUS.

  This License represents the complete agreement concerning subject
  matter hereof. Nothing in this AGREEMENT shall be construed as
  conferring by implication, estoppel or otherwise any license or
  rights other than those granted in this License. If any provision of
  this License is held to be unenforceable, such provision shall be
  reformed only to the extent necessary to make it enforceable. This
  License shall be governed by Utah law provisions (except to the
  extent applicable law, if any, provides otherwise). The application
  of the United Nations Convention on Contracts for the International
  Sale of Goods is expressly excluded. Any law or regulation which
  provides that the language of a contract shall be construed against
  the drafter shall not apply to this License.

EXHIBIT A.

The contents of this file are subject to the University of Utah Public
License (the "License"); you may not use this file except in
compliance with the License.

Software distributed under the License is distributed on an "AS IS"
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See
the License for the specific language governing rights and limitations
under the License.

The Original Source Code is "Parallel Grid Rebuild", released September 18, 2006.

The Original Source Code was developed by the University of Utah.
Portions created by UNIVERSITY are Copyright (C) 2006 University
of Utah. All Rights Reserved.
*/

#include "XRay/Grid.hxx"
#include "base/Clock.hxx"

#ifdef USE_NUMA
#include <numa.h>
#include <sched.h>
#include "XRay.hxx"
#endif

//around 5 is good for smaller models. ~1 is good for larger.
float Grid::resolutionFactor = 1.0f;

#define DISPLAY_BUILD_TIMES true

//#define SERIAL_BUILD // only for debugging

//barrier to wait for NUM_BUILD_THREADS
#define barrier(mutex, condition)                           \
  {                                                         \
    static int count = NUM_BUILD_THREADS;                   \
    pthread_mutex_lock( &mutex );                           \
    --count;                                                \
    if (count > 0)                                          \
      pthread_cond_wait( &condition, &mutex );              \
    else {                                                  \
      pthread_cond_broadcast( &condition );                 \
      count = NUM_BUILD_THREADS;                            \
    }                                                       \
    pthread_mutex_unlock( &mutex );                         \
  }                                                         \


void Grid::preprocess(const int myThreadID)
{
  static bool firstTime = true;
#ifdef NUM_BUILD_THREADS
  static pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
  static pthread_mutex_t countMutex = PTHREAD_MUTEX_INITIALIZER;
  static pthread_cond_t condition = PTHREAD_COND_INITIALIZER;
  static pthread_mutex_t condition_mutex = PTHREAD_MUTEX_INITIALIZER;
#endif
  vector<CellData> &restrict myVector = cellVector;

  CellData *myCell;

  Clock firstClock;
  static Clock c;

  firstClock.start();

#ifdef MACRO_CELLS
  static int oldN_mc[3] = { -1, -1, -1 };
#endif
  static int oldN[3] = { -1, -1, -1 };

#ifdef NUM_BUILD_THREADS
  pthread_mutex_lock(&mutex);
  static bool first = true;
  if (first) {
    first = false;
    pthread_mutex_unlock(&mutex);
#endif
    c.start();

#ifdef MAILBOXING
    //initialize_mailbox();
#endif

    bounds = mesh->bounds;
    sse_t epsilon = mul4(bounds.diameter(), set4(1e-4f));
    bounds.min = sub4(bounds.min,epsilon);
    bounds.max = add4(bounds.max,epsilon);
    if (mesh->triangles == 0)
      return;
    diam = bounds.diameter();

    if (firstTime)
      cout << "diameter " << diam << endl;
    if (!firstTime) {
#ifdef MACRO_CELLS
      oldN_mc[0] = N_mc[0];
      oldN_mc[1] = N_mc[1];
      oldN_mc[2] = N_mc[2];
#endif
      oldN[0] = N[0];
      oldN[1] = N[1];
      oldN[2] = N[2];
    }

    float factor = resolutionFactor;
    ALIGN(16)
    float _diam[4];
    for (int i=0; i < 4; ++i)
      _diam[i] = ((float4&)diam)[i];//store4(_diam,diam);
    N[0] = (int)(powf(factor * mesh->triangles * _diam[0] * _diam[0] / (_diam[1] * _diam[2]), 1/3.));
    N[1] = (int)(powf(factor * mesh->triangles * _diam[1] * _diam[1] / (_diam[0] * _diam[2]), 1/3.));
    N[2] = (int)(powf(factor * mesh->triangles * _diam[2] * _diam[2] / (_diam[1] * _diam[0]), 1/3.));
    
    N[0] = max(N[0],3);
    N[1] = max(N[1],3);
    N[2] = max(N[2],3);

    M[0] = N[0]-1;
    M[1] = N[1]-1;
    M[2] = N[2]-1;

#ifdef MACRO_CELLS
    for (int i=0;i<3;i++)
    {
      N_mc[i] = ((N[i]-1) / MACRO_CELLS + 1);
      M_mc[i] = N_mc[i] - 1;
      N[i] = N_mc[i] * MACRO_CELLS;
      M[i] = N[i] - 1;
    }
#endif
    if (firstTime)
      cout << "grid resolution " << N[0] << " " << N[1] << " " << N[2] << endl;

    sse_N = set44(0,N[2],N[1],N[0]);
    sse_M = set44(0,M[2],M[1],M[0]);
    sse_one_over_N = accurateReciprocal(sse_N);
  
    scale = accurateReciprocal(diam);
    scaleN = mul4(sse_N,accurateReciprocal(diam));
    scaleM = mul4(sse_M,accurateReciprocal(diam));
  
    if (myVector.size() < N[0]*N[1]*N[2]) {
      int oldSize = myVector.size();
      myVector.resize(N[0]*N[1]*N[2]);

#if defined(MUTEX_BUILD)
      cell_mutexes.resize(N[0]*N[1]*N[2]);
      for (int i = oldSize; i < myVector.size(); ++i) {
        pthread_mutex_init(&cell_mutexes[i], NULL);
      }
#endif //MUTEX_BUILD

    }

    if (firstTime)
      cout << "building grid for " << mesh->triangles << " triangles, res = " << N[0] << "x" << N[1] << "x" << N[2] << endl << "bounds = " << bounds << endl;

    firstClock.stop();

    if (firstTime || DISPLAY_BUILD_TIMES)
      cout << "first stage of grid build : " << firstClock.msecs() << "ms" << endl;

#ifdef NUM_BUILD_THREADS
  }
  else
    pthread_mutex_unlock(&mutex);

  barrier(condition_mutex, condition);
  
#ifdef SERIAL_BUILD
  pthread_mutex_lock(&mutex);
#endif

#endif //NUM_BUILD_THREADS

  myCell = &myVector[0];

  Clock clearClock;
  clearClock.start();

#if 0 || !defined(MACRO_CELLS)
#ifdef NUM_BUILD_THREADS
  const int start_z = (oldN[2] * myThreadID) / NUM_BUILD_THREADS;
  const int end_z = (oldN[2] * (myThreadID+1)) / NUM_BUILD_THREADS;
#else
  const int start_z = 0;
  const int end_z = oldN[2];
#endif //NUM_BUILD_THREADS
  for (int i=oldN[0]*oldN[1]*start_z;i<oldN[0]*oldN[1]*end_z;i++) {
//         if (myCell[i].triIDs.size() > 500)
//             myCell[i].triIDs.clear();
    myCell[i].triIDs.resize(0);
  }

#else

  //we can use the previous macrocell grid to quickly get to the cells
  //that had triangles and just clear those.
#if !defined(NUM_BUILD_THREADS)
  for (int z = 0; z < oldN_mc[2]; ++z) {
    for (int y = 0; y < oldN_mc[1]; ++y) {
#else
  const int oldlength = oldN_mc[1]*oldN_mc[2] - 1;
  const int start_z = oldlength*myThreadID / 
    (oldN_mc[1]*NUM_BUILD_THREADS);
  const int end_z = oldlength*(myThreadID+1) / 
    (oldN_mc[1]*NUM_BUILD_THREADS);
  const int start_y = oldlength*myThreadID / NUM_BUILD_THREADS -
    start_z*oldN_mc[1];
  const int end_y = oldlength*(myThreadID+1) / NUM_BUILD_THREADS -
    end_z*oldN_mc[1] + ((myThreadID+1) == NUM_BUILD_THREADS);

  for (int z = start_z; z<=end_z; z++) {
    for (int y = ((z==start_z)? start_y: 0);
         y < ((z==end_z)? end_y:oldN_mc[1]); y++) {
#endif
      for (int x=0; x < oldN_mc[0]; x++) {
        int ofs = x+oldN_mc[0]*(y+oldN_mc[1]*(z));
        if (cellVector_mc[ofs] > 0) {
          int id = (x*MACRO_CELLS) + 
            oldN[0]*( y*MACRO_CELLS + 
                      oldN[1]*z*MACRO_CELLS);
          for (int mz=0;mz<MACRO_CELLS;mz++) {
            for (int my=0;my<MACRO_CELLS;my++) {
              for (int mx=0;mx<MACRO_CELLS;mx++) {
//                 if (myCell[id].triIDs.size() > 500)
//                   myCell[id].triIDs.clear();
//                  else
                myCell[id].triIDs.resize(0);
                //myCell[id].triIDs.clear();
                id++;
              }
              id += oldN[0] - MACRO_CELLS; 
            }
            id += oldN[0] * (oldN[1] - MACRO_CELLS);
          }
        }
      }
    }
  }
#endif //macro cell clear

  clearClock.stop();
  if (firstTime || DISPLAY_BUILD_TIMES)
  {
    char buf[128];
    sprintf(buf, "%d: time to clear old grid: %fms\n", 
           myThreadID, clearClock.usecs()*1e-3);
    cout<<buf;
  }

#ifdef SERIAL_BUILD
  pthread_mutex_unlock(&mutex);
#endif

#ifdef NUM_BUILD_THREADS

#if !defined(SORT_LAST_BUILD)
  //TODO: this assumes number of triangles does not change!
  if (buildQueues[myThreadID][0] == NULL)
    for (int i=0; i < NUM_BUILD_THREADS; ++i) {
      
      //XXXXXX need to convert from array to vector since we do not
      //know how many tri will be in each queue since one triangle
      //can be in more than one cell.
#if NUM_BUILD_THREADS > 1
      const int SCALER = 4;
#else
      const int SCALER = 10;
#endif //NUM_BUILD_THREADS

#if !defined(__linux__) || !defined(USE_NUMA) || 0
      buildQueues[myThreadID][i] = new location_primitive[SCALER*mesh->triangles];
#else
      const int node = RayTraceRenderer::getBuildPreprocessNode(myThreadID);
      const int node2 = RayTraceRenderer::getBuildPreprocessNode(i);

      nodemask_t interleaveNodes;
      nodemask_zero(&interleaveNodes);
      nodemask_set(&interleaveNodes, node);

#if 1
      //local allocation might be best since the engridding stage
      //writes randomly to the myThread queues (all local). The
      //merge step will stream ALL the queue data from the far
      //node at once, so caching will compensate.
      //Also, I think when interleaving among 2 nodes the actual
      //total number of local misses will end up being the same.
      nodemask_set(&interleaveNodes, node2);
#endif
      buildQueues[myThreadID][i] = (location_primitive*) 
        numa_alloc_interleaved_subset(SCALER*mesh->triangles * 
                                      sizeof(location_primitive),
                                      &interleaveNodes);
#endif
    }
  location_primitive **const restrict myBuildQueues = 
    &buildQueues[myThreadID][0];

  //to reduce false sharing we create this buildQueue counter
  //and use it while engridding instead of the array of counters.
  int myBuildQueue_sizes[NUM_BUILD_THREADS] = {0};
#endif //! SORT_LAST_BUILD

//   printf("thread %d exited first barrier\n", myThreadID);
  const int numTri = mesh->triangles;
  const int startTri = (numTri * myThreadID) / NUM_BUILD_THREADS;
  const int endTri = (numTri * (myThreadID+1)) / NUM_BUILD_THREADS;

  //even though we don't really need a barrier here, this
  //ends up, I think, not slowing down the code and it produces
  //nicer more uniform and easier to understand timings.
  //Make sure to double check when getting overall best timings 
  //whether this is slowing down the code...
  barrier(condition_mutex, condition);

#ifdef SERIAL_BUILD
  pthread_mutex_lock(&mutex);
#endif

#else
  const int startTri = 0;
  const int endTri = mesh->triangles;
#endif //NUM_BUILD_THREADS

  Clock engriddingClock;
  engriddingClock.start();

  for (int i = startTri; i < endTri; i++) {

#ifdef TRI_PREPROCESS
    Box4 triBounds;
    {
      //triangle_preprocess(); 
    }
#else
    Box4 triBounds = mesh->getTriBounds(i);
#endif

    // scale by N ? or rather by M ?
    triBounds.min = mul4(scaleN,sub4(triBounds.min,bounds.min));
    triBounds.max = mul4(scaleN,sub4(triBounds.max,bounds.min));

    union {
      sse_int_t clampedAsInt;
      int xyz[4];
    };
    clampedAsInt =cast4_fi(triBounds.min);
    int x0 = xyz[0];
    int y0 = xyz[1];
    int z0 = xyz[2];
    clampedAsInt =cast4_fi(triBounds.max);
    int x1 = xyz[0];
    int y1 = xyz[1];
    int z1 = xyz[2];

    int c = x0 + N[0]*(y0+N[1]*z0);
    const int numCells = (z1-z0+1)*(y1-y0+1)*(x1-x0+1);
    
#ifdef MUTEX_POOL
    int ofs = x0/MACRO_CELLS + N_mc[0]*(y0/MACRO_CELLS + N_mc[1]*(z0/MACRO_CELLS));
    int lockID = ofs;
    pthread_mutex_lock( &cell_mutexes[ofs]);
#endif //MUTEX_POOL

    for (int z=z0; z<=z1; z++) {

#if defined(NUM_BUILD_THREADS) && !defined(SORT_LAST_BUILD)
#if ((NUM_BUILD_THREADS & (NUM_BUILD_THREADS-1)) == 0) //power of 2?
      int q = z & (NUM_BUILD_THREADS-1);
#else
      int q = z % (NUM_BUILD_THREADS);
#endif // (NUM_BUILD_THREADS%2 == 0)
#endif // defined(NUM_BUILD_THREADS)

      for (int y=y0; y<=y1; y++) {
        for (int x=x0; x<=x1; x++) {
#ifdef MUTEX_POOL
          ofs = x/MACRO_CELLS + N_mc[0]*(y/MACRO_CELLS + N_mc[1]*(z/MACRO_CELLS));
          if (ofs != lockID) {
            pthread_mutex_unlock( &cell_mutexes[lockID]);
            lockID = ofs;
            pthread_mutex_lock( &cell_mutexes[ofs]);
          }
#endif //MUTEX_POOL
          
#if 0
          if (numCells >= 4) {
            //This is not at all optimized for sse, but does give correct results.
            const Box4 wcb = worldCellBounds(x,y,z);
            //XXXX add Triangle Bounding Box overlap test:
            if (! triBoxOverlap( i, wcb) ) {
              ++c;
              continue;
            }
          }
#endif

#if defined(NUM_BUILD_THREADS) && !defined(SORT_LAST_BUILD)
          myBuildQueues[q][myBuildQueue_sizes[q]].gridLocation = c;
          myBuildQueues[q][myBuildQueue_sizes[q]].which_primitive = i;
          ++myBuildQueue_sizes[q];
#else        
# if defined(MUTEX_BUILD) && !defined(MUTEX_POOL)
          pthread_mutex_lock( &cell_mutexes[c]);
# endif // MUTEX_BUILD && !(MUTEX_POOL)
          myCell[c].triIDs.push_back(i);
# if defined(MUTEX_BUILD) && !defined(MUTEX_POOL)
          pthread_mutex_unlock( &cell_mutexes[c]);
# endif // MUTEX_BUILD && !(MUTEX_POOL)
#endif //NUM_BUILD_THREADS && !SORT_LAST_BUILD
          ++c;
        }
        c += N[0] - (x1-x0+1);
      }
      c += N[0]*(N[1] - (y1-y0+1));
    }
#ifdef MUTEX_POOL
    pthread_mutex_unlock( &cell_mutexes[lockID]);
#endif //MUTEX_POOL
  }

  engriddingClock.stop();
  if (DISPLAY_BUILD_TIMES) {
    char buf[128];
    sprintf(buf, "%d engriddingClock time: %fms\n", 
           myThreadID, engriddingClock.usecs()*1e-3f);
    cout<<buf;
  }
  
#ifdef SERIAL_BUILD
  pthread_mutex_unlock(&mutex);
#endif

#if defined(NUM_BUILD_THREADS) && !defined(SORT_LAST_BUILD)
  for (int i=0; i < NUM_BUILD_THREADS; ++i)
    buildQueue_sizes[myThreadID][i] = myBuildQueue_sizes[i];

  barrier(condition_mutex, condition);

#ifdef SERIAL_BUILD
  pthread_mutex_lock(&mutex);
#endif

  Clock mergeClock;
  mergeClock.start();

  for (int i=0; i < NUM_BUILD_THREADS; i++) {
    for (int k=0; k < buildQueue_sizes[i][myThreadID]; ++k) {
      const location_primitive &restrict prim_lp = 
        buildQueues[i][myThreadID][k];
      
      myCell[prim_lp.gridLocation].triIDs.push_back(prim_lp.which_primitive);
    }
  }

  mergeClock.stop();
  if (DISPLAY_BUILD_TIMES) {
    char buf[128];
    sprintf(buf, "%d merge time: %fms\n", 
            myThreadID, mergeClock.usecs()*1e-3f);
    cout<<buf;
  }

#ifdef SERIAL_BUILD
  pthread_mutex_unlock(&mutex);
#endif

#endif //NUM_BUILD_THREADS && !defined(SORT_LAST_BUILD)

#ifdef MACRO_CELLS
  //cout << "macrocell-res " << N_mc[0] << "x" << N_mc[1] << "x" << N_mc[2] << endl;
#ifdef NUM_BUILD_THREADS
  if (myThreadID == 0)
    if (cellVector_mc.size() < N_mc[0]*N_mc[1]*N_mc[2])
      cellVector_mc.resize(N_mc[0]*N_mc[1]*N_mc[2]);

  barrier(condition_mutex, condition);
  
#ifdef SERIAL_BUILD
  pthread_mutex_lock(&mutex);
#endif

#else
  if (cellVector_mc.size() < N_mc[0]*N_mc[1]*N_mc[2])
    cellVector_mc.resize(N_mc[0]*N_mc[1]*N_mc[2]);
#endif //NUM_BUILD_THREADS

  Clock macroBuildClock;
  macroBuildClock.start();

#ifndef NUM_BUILD_THREADS
  for (int iz = 0; iz<N_mc[2]; iz++)
    for (int iy = 0; iy<N_mc[1]; iy++)
#else
  const int length = N_mc[1]*N_mc[2] - 1;
  const int start_iz = length*myThreadID / 
    (N_mc[1]*NUM_BUILD_THREADS);
  const int end_iz = length*(myThreadID+1) / 
    (N_mc[1]*NUM_BUILD_THREADS);
  const int start_iy = length*myThreadID / NUM_BUILD_THREADS -
    start_iz*N_mc[1];
  const int end_iy = length*(myThreadID+1) / NUM_BUILD_THREADS -
    end_iz*N_mc[1] + ((myThreadID+1) == NUM_BUILD_THREADS);

  for (int iz = start_iz; iz<=end_iz; iz++)
    for (int iy = ((iz==start_iz)? start_iy: 0);
         iy < ((iz==end_iz)? end_iy:N_mc[1]); iy++) 
#endif //NUM_BUILD_THREADS
      for (int ix = 0;ix<N_mc[0];ix++) {
        int count = 0;
        int id = (ix*MACRO_CELLS) + 
                  N[0]*( iy*MACRO_CELLS + 
                         N[1]*iz*MACRO_CELLS);
        for (int mz=0;mz<MACRO_CELLS;mz++) {
          for (int my=0;my<MACRO_CELLS;my++) {
            for (int mx=0;mx<MACRO_CELLS;mx++) {
//Expanding this out gives a 10% improvement in macrocell build time.
//                int id2 = idx(ix*MACRO_CELLS+mx,
//                              iy*MACRO_CELLS+my,
//                              iz*MACRO_CELLS+mz);
              count += myVector[id].triIDs.size();
              id++;
            }
            if (count) goto endMacroCell;
            id += N[0] - MACRO_CELLS;
          }
          id += N[0] * (N[1] - MACRO_CELLS);
        }
      endMacroCell:
        set_mc(ix,iy,iz,count);
      }

  macroBuildClock.stop();
  if (DISPLAY_BUILD_TIMES) {
    char buf[128];
    sprintf(buf, "%d macro cell build time: %fms\n", 
            myThreadID, macroBuildClock.usecs()*1e-3f);
    cout<<buf;
  }
  
#ifdef SERIAL_BUILD
  pthread_mutex_unlock(&mutex);
#endif

#endif // MACRO_CELLS

#ifdef NUM_BUILD_THREADS
  { //only let the last thread through so it can cleaup.
    static int done_count = NUM_BUILD_THREADS;
    pthread_mutex_lock(&mutex);
    if (--done_count != 0) {
      pthread_mutex_unlock(&mutex);
      return;
    }
    pthread_mutex_unlock(&mutex);
    done_count = NUM_BUILD_THREADS;
  }

  first = true;
#endif

  c.stop();

  if (firstTime|| DISPLAY_BUILD_TIMES)
    cout << "grid built in " << c.usecs()*1e-3f << "ms" << endl << endl;
  firstTime = false;
};
